//+------------------------------------------------------------------+
//|              INTERSECTING TIME FRAMES                            |
//+------------------------------------------------------------------+
extern double TakeProfit = 500;
extern double Lots = 1;
extern double TrailingStop = 35;
extern double MA5=5;
extern double MA26=26;
extern double MA62=62;
extern double MACDCharttime = 0;
extern int FastLength = 12;
extern int SlowLength = 26;
extern int MACDLength =  9; 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {  
   int    shift, back, lasthighpos, lastlowpos, Snitch;
   double val, res, SarCurrent, Oldclose;
   double MacdCurrent,   MacdPrevious;
   double SignalCurrent, SignalPrevious;
   double MaCur5,     MaPrevious, MaRec26;
   double MaCur1,        MaPre1,    MaRec1;
   double MacdDiffy, MacDuff;
   int cnt, ticket, total;
   int limit;
   int count=HistoryTotal();

   for(cnt=0;cnt<count;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);
   //if((CurTime() - OrderOpenTime())  < (Period() * 60 )) 
   //{
   //Sleep(6000);
   //Print("Too soon since last trade");
   //return(0);
   //}
   //else Print((CurTime() - OrderOpenTime())," ",(60 * Period()));
   }
   
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }   
    
   //SarCurrent    = iSAR(NULL,0,0.02,0.2,0) ;

   MaCur5 =iMA(NULL,MACDCharttime,MA5,0,MODE_EMA,PRICE_CLOSE,0);
   MaRec26 =iMA(NULL,MACDCharttime,MA26,0,MODE_EMA,PRICE_CLOSE,0);
   
   MaCur1 =iMA(NULL,MACDCharttime,MA5,0,MODE_EMA,PRICE_CLOSE,1);
   MaRec1 =iMA(NULL,MACDCharttime,MA26,0,MODE_EMA,PRICE_CLOSE,1);
  
   MacdCurrent  = iMACD(NULL,MACDCharttime,FastLength,SlowLength,MACDLength,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious = iMACD(NULL,MACDCharttime,FastLength,SlowLength,MACDLength,PRICE_CLOSE,MODE_MAIN,1);
   
   SignalCurrent  = iMACD(NULL,MACDCharttime,FastLength,SlowLength,MACDLength,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious = iMACD(NULL,MACDCharttime,FastLength,SlowLength,MACDLength,PRICE_CLOSE,MODE_SIGNAL,1);
    
   MacdDiffy = (MacdCurrent -  SignalCurrent);   
   MacDuff   = (MacdPrevious - SignalPrevious);
   
   total=0; 
  
   for(int tckt=0;tckt<count;tckt++)
    {
     OrderSelect(tckt, SELECT_BY_POS, MODE_TRADES);
     if(OrderSymbol()==Symbol()) 
     {
     total = total + 1;     
     }
    }

   if(total<2) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(200*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
  
       //  Comment(Close," Macd Diff : ",MacdDiffy," Old Macd Diff : ",MacDuff," Switch On : ",Snitch);   
       // check for long position (BUY) possibility
 
     if //(MacdDiffy >= 0.00015 &&
        // the cross is first 
        ( MaCur1     < MaRec1 &&
          MaCur5     > MaRec26 &&
          MaCur5     > MaCur1  &&
          MaRec26    > MaRec1  
          )
     {
        //Comment("BUY : ",Ask," Macd Diff : ",MacdDiffy);
        ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-Point*TrailingStop,Ask+TakeProfit*Point,"526Cross",16384,0,Yellow);
        if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
        else Print("Error opening BUY order : ",GetLastError()); 
        return(0); 
     }
 
    // check for short position (SELL) possibility
    // Bid < SarCurrent )
 
    if  ( MaCur1  > MaRec1 &&
          MaCur5  < MaRec26 &&
          MaCur5  < MaCur1  &&
          MaRec26 < MaRec1  
           )
    //(MacdDiffy <= -0.00015 && 
    //    MaCurrent < (MaRecent-Point*risenfall))   
    //    MaCurrent < MaPrevious  &&  
    //    MaRecent  < (MaPrevious-Point*risenfall) && 
        {
       
        //Comment("SELL : ",Bid," Macd Diff : ",MacdDiffy);
        ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+Point*TrailingStop,Bid-TakeProfit*Point,"526Cross",16384,0,Red);
        if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
        else Print("Error opening SELL order : ",GetLastError()); 
        return(0); 
        }
      //return(0);
     }

   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...        
   cnt = -1;
   Oldclose = -1;
      
   for(cnt=0;cnt<count;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())  // check for symbol
        {
        Oldclose = OrderOpenPrice();
        //Print(":",(count),":",cnt," Old : ", Oldclose," New : ", Close[0]);
        //Comment(":",(count),":",cnt," Old : ", Oldclose," New : ", Close[0]);
   
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            // check for trailing stop
         if(((Close[0] > Oldclose) && (OrderStopLoss() < Bid-Point*TrailingStop)))
              {                 
                     //Print("modify buy : ",count,":",cnt," Old : ", Oldclose," New : ", Close[0]);
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
              }
           }
         else // go to short position
           {
            // should it be closed?
            // check for trailing stop
         if(((Close[0] < Oldclose) && (OrderStopLoss() > Ask+Point*TrailingStop))) 
              {                 
                     //Print("modify sell: ",count,":",cnt," Old : ", Oldclose," New : ", Close[0]);
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
              }
           }
        }
     }
   return(0);
  }
// the end.